unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, math, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    Desk: TImage;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    Queen: TImage;
    N3: TMenuItem;
    N4: TMenuItem;
    procedure DeskMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure DeskClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure NewGame(Sender: TObject);
    procedure Paint;
    procedure Rules(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  x1, y1, a, i, j, n, Xmouse, Ymouse, Xt, Yt, Xt1, Yt1, Xn, Yn, k,l, k0, l0 : integer;
  m : array [1..8,1..8] of integer;
  f : boolean;
  st, regime : string;

implementation


{$R *.DFM}

procedure Tform1.Paint;  //     1 
begin
  Desk.Canvas.brush.color:= clwhite;
  Desk.Canvas.Rectangle(0,0,Desk.Width,Desk.Height);

  For i:=0 to 8 do
   begin
    Desk.Canvas.MoveTo (x1*i,0);
    Desk.Canvas.LineTo (x1*i,y1*8);
    Desk.Canvas.MoveTo (0,y1*i);
    Desk.Canvas.LineTo (x1*8,y1*i);
   end;
end;


procedure TForm1.DeskMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Xmouse:= x;
  Ymouse:= y;
end;

procedure TForm1.DeskClick(Sender: TObject); //     1 ()
begin
If Regime = 'Manual' then
 BEGIN
  Xt:= ceil(Xmouse/x1);
  Yt:= ceil(Ymouse/y1);
  Xn:= Xt;  //   ,   
  Yn:= Yt;

  If f = false then   //  
    begin
      f:= true;
      Queen.Visible:= true;
      Queen.Left:= (Xt - 1)*x1 + 4;
      Queen.Top:= (Yt - 1)*y1 + 4;
      Desk.Canvas.brush.color:= clSilver;
      Desk.Canvas.Rectangle((Xt-1)*x1,(Yt-1)*y1,Xt*x1,Yt*y1);
      n:= n+1;
      k:= ceil(Xt/x1);
      l:= ceil(Yt/x1);
      m[k,l]:=2; {unic index}
      k0:= k;
      l0:= l;
      Xt1:= Xt;
      Yt1:= Yt;
    end
   Else  //  
    begin
     For i:=0 to 8 do
       begin
        If
         (((Xt1 = Xt+i) and (Yt1 = Yt+i)) or ((Xt1 = Xt) and (Yt1 = Yt-i)) or
         ((Xt1 = Xt) and (Yt1 = Yt+i)) or ((Xt1 = Xt-i) and (Yt1 = Yt)) or
         ((Xt1 = Xt+i) and (Yt1 = Yt-i)) or ((Xt1 = Xt+i) and (Yt1 = Yt)) or
         ((Xt1 = Xt-i) and (Yt1 = Yt-i)) or ((Xt1 = Xt-i) and (Yt1 = Yt+i)))
        Then
          If (m[k,l]=0) or (m[k,l]=1) or (m[k,l] = 2) then
                                             begin
                                              Queen.Left:=((Xt-1)*x1+2);
                                              Queen.Top:= ((Yt-1)*y1+3);
                                              n:= n+1;
    {   "",  } { If (Xt = Xn) and (Yt = Yn) then }
                                              Desk.Canvas.brush.color:= clMaroon;
                                              Desk.Canvas.Rectangle((Xt-1)*x1,(Yt-1)*y1,Xt*x1,Yt*y1);
                                              k:= ceil(Xt/x1);
                                              l:= ceil(Yt/x1);
                                              If (k <> k0) and (l <> l0) then
                                              m[k,l]:= 1;
                                              Xt1:= Xt;
                                              Yt1:= Yt;
                                             end;
       end;
    end;
 END;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

f:= false;
x1:= 40;
y1:= 40;
paint;

For i:= 1 to 8 do
 For j:= 1 to 8 do
   m[i,j]:=0;

end;

procedure TForm1.NewGame(Sender: TObject);
begin

f:= false;
Queen.Visible:= false;
paint;

For i:=1 to 8 do
 For j:= 1 to 8 do
  m[i,j]:= 0;

n:= 0;

end;


procedure TForm1.Rules(Sender: TObject);
begin
ShowMessage ('       ,       ');
end;

procedure TForm1.N3Click(Sender: TObject);
begin
Regime:= 'Manual';
end;

procedure TForm1.N4Click(Sender: TObject);
begin
Regime:= 'Auto';
end;

end.
